#
# ISP RAS (http://www.ispras.ru)
#
# This ruby template was automatically generated by the MicroTESK tool
# Generation started: Fri Dec 27 11:14:34 MSK 2019
#

require_relative 'minimips_base'

class SequenceGenTemplate < MiniMipsBaseTemplate
  def pre
    super
    data {
      label :data
      word rand(1, 9), rand(1, 9), rand(1, 9), rand(1, 9)
      label :end_data
      space 1
    }
  end
  
  def run
    set_default_allocator FREE
    
    # Only arithmetic operations
    
    sequence {
      add reg(_), reg(_), reg(_)      
      add reg(_), reg(_), reg(_)      
      add reg(_), reg(_), reg(_)      
      add reg(_), reg(_), reg(_)      
      add reg(_), reg(_), reg(_)      
    }.run
    
    sequence {
      addi reg(_), reg(_), _      
      addi reg(_), reg(_), _      
      addi reg(_), reg(_), _      
      addi reg(_), reg(_), _      
      addi reg(_), reg(_), _      
    }.run
    
    sequence {
      addu reg(_), reg(_), reg(_)      
      addu reg(_), reg(_), reg(_)      
      addu reg(_), reg(_), reg(_)      
      addu reg(_), reg(_), reg(_)      
      addu reg(_), reg(_), reg(_)      
    }.run
    
    sequence {
      addiu reg(_), reg(_), _      
      addiu reg(_), reg(_), _      
      addiu reg(_), reg(_), _      
      addiu reg(_), reg(_), _      
      addiu reg(_), reg(_), _      
    }.run
    
    sequence {
      sub reg(_), reg(_), reg(_)      
      sub reg(_), reg(_), reg(_)      
      sub reg(_), reg(_), reg(_)      
      sub reg(_), reg(_), reg(_)      
      sub reg(_), reg(_), reg(_)      
    }.run
    
    sequence {
      subu reg(_), reg(_), reg(_)      
      subu reg(_), reg(_), reg(_)      
      subu reg(_), reg(_), reg(_)      
      subu reg(_), reg(_), reg(_)      
      subu reg(_), reg(_), reg(_)      
    }.run
    
    sequence {
      AND reg(_), reg(_), reg(_)      
      AND reg(_), reg(_), reg(_)      
      AND reg(_), reg(_), reg(_)      
      AND reg(_), reg(_), reg(_)      
      AND reg(_), reg(_), reg(_)      
    }.run
    
    sequence {
      andi reg(_), reg(_), _      
      andi reg(_), reg(_), _      
      andi reg(_), reg(_), _      
      andi reg(_), reg(_), _      
      andi reg(_), reg(_), _      
    }.run
    
    sequence {
      OR reg(_), reg(_), reg(_)      
      OR reg(_), reg(_), reg(_)      
      OR reg(_), reg(_), reg(_)      
      OR reg(_), reg(_), reg(_)      
      OR reg(_), reg(_), reg(_)      
    }.run
    
    sequence {
      ori reg(_), reg(_), _      
      ori reg(_), reg(_), _      
      ori reg(_), reg(_), _      
      ori reg(_), reg(_), _      
      ori reg(_), reg(_), _      
    }.run
    
    sequence {
      nor reg(_), reg(_), reg(_)      
      nor reg(_), reg(_), reg(_)      
      nor reg(_), reg(_), reg(_)      
      nor reg(_), reg(_), reg(_)      
      nor reg(_), reg(_), reg(_)      
    }.run
    
    sequence {
      xor reg(_), reg(_), reg(_)      
      xor reg(_), reg(_), reg(_)      
      xor reg(_), reg(_), reg(_)      
      xor reg(_), reg(_), reg(_)      
      xor reg(_), reg(_), reg(_)      
    }.run
    
    sequence {
      xori reg(_), reg(_), _      
      xori reg(_), reg(_), _      
      xori reg(_), reg(_), _      
      xori reg(_), reg(_), _      
      xori reg(_), reg(_), _      
    }.run
    
    sequence {
      sll reg(_), reg(_), _      
      sll reg(_), reg(_), _      
      sll reg(_), reg(_), _      
      sll reg(_), reg(_), _      
      sll reg(_), reg(_), _      
    }.run
    
    sequence {
      sllv reg(_), reg(_), reg(_)      
      sllv reg(_), reg(_), reg(_)      
      sllv reg(_), reg(_), reg(_)      
      sllv reg(_), reg(_), reg(_)      
      sllv reg(_), reg(_), reg(_)      
    }.run
    
    sequence {
      sra reg(_), reg(_), _      
      sra reg(_), reg(_), _      
      sra reg(_), reg(_), _      
      sra reg(_), reg(_), _      
      sra reg(_), reg(_), _      
    }.run
    
    sequence {
      srav reg(_), reg(_), reg(_)      
      srav reg(_), reg(_), reg(_)      
      srav reg(_), reg(_), reg(_)      
      srav reg(_), reg(_), reg(_)      
      srav reg(_), reg(_), reg(_)      
    }.run
    
    sequence {
      srl reg(_), reg(_), _      
      srl reg(_), reg(_), _      
      srl reg(_), reg(_), _      
      srl reg(_), reg(_), _      
      srl reg(_), reg(_), _      
    }.run
    
    sequence {
      srlv reg(_), reg(_), reg(_)      
      srlv reg(_), reg(_), reg(_)      
      srlv reg(_), reg(_), reg(_)      
      srlv reg(_), reg(_), reg(_)      
      srlv reg(_), reg(_), reg(_)      
    }.run
    
    sequence {
      slt reg(_), reg(_), reg(_)      
      slt reg(_), reg(_), reg(_)      
      slt reg(_), reg(_), reg(_)      
      slt reg(_), reg(_), reg(_)      
      slt reg(_), reg(_), reg(_)      
    }.run
    
    sequence {
      slti reg(_), reg(_), _      
      slti reg(_), reg(_), _      
      slti reg(_), reg(_), _      
      slti reg(_), reg(_), _      
      slti reg(_), reg(_), _      
    }.run
    
    sequence {
      sltiu reg(_), reg(_), _      
      sltiu reg(_), reg(_), _      
      sltiu reg(_), reg(_), _      
      sltiu reg(_), reg(_), _      
      sltiu reg(_), reg(_), _      
    }.run
    
    sequence {
      sltu reg(_), reg(_), reg(_)      
      sltu reg(_), reg(_), reg(_)      
      sltu reg(_), reg(_), reg(_)      
      sltu reg(_), reg(_), reg(_)      
      sltu reg(_), reg(_), reg(_)      
    }.run
  end
end
